#ifndef TYPEDEF_H
#define TYPEDEF_H

#define S_WIDTH  128
#define S_HEIGHT 128

// TIME CONSTANTS ----------------------------------------------------------------------------
    #define OLED_REFRESH         60

// HARDWARE CONFIG ----------------------------------------------------------------------------
   
    // DISPLAY
    #define DISPLAY_DC        15 // Data/command pin 23 dans boitier tictac
    #define DISPLAY_RESET     14 // Reset pin for displays 22 dans boitier tictac
    #define DISPLAY_CS_PIN    10 // display select pin 21 dans boitier tictac
    #define DISPLAY_CLK       13 // idem  boitier tictac
    #define DISPLAY_DATA      11 // idem  boitier tictac

    // BUZZER
    #define BUZZER_PIN        5 // 
    
    // SWITCH
    #define UP_PIN            21 
    #define MID_PIN           9
    #define DOWN_PIN          16

    // JOYSTICK
    #define JOYX_PIN          A3
    #define JOYY_PIN          A8

    // GYRO
    #define INT_PIN           2 // To be check

// TIME CONSTANTS ----------------------------------------------------------------------------

    #define SLEEP_DELAY          120000
    #define DEEPSLEEP_DELAY      240000

    // BUZZER
    #define DO              261.63
    #define RE              293.66
    #define MI              329.63
    #define FA              349.23
    #define SOL             392
    #define LA              440
    #define SI              493.88
    #define DO1             523.25
   
typedef struct Vector
            {
               int16_t x;
               int16_t y;
            } Vector ;


typedef struct Conf 
{
        uint8_t level;              // playing level 
        uint8_t maxLevel;           // max reached level
        boolean enableSound;        // activate sound
        boolean enableGyro;         // activate Gyro
        boolean playGyro;           // Play with Gyro
        boolean enableLoopTime;     // activate loopTime display
        boolean screenSens;
        boolean enableShadowMode;
        boolean enableDeepSleepMode;
} Conf ;

typedef struct Skin
            {
               const uint16_t *skin;
               const uint8_t  width;
               const uint8_t  height;
               const uint8_t  frameNb;
               const uint8_t  widthMask;
            } Skin ;


#endif
