


#include <Arduino.h>
#include "Config.h"
#include "Input.h"
#include <FastSSD1351.h>
#include "Player.h"
#include "Game.h"

extern FastSSD1351 oled;   // objet graphique
extern Switch  swUp, swMid, swDown ;                 // declaration objet switch , swJoy 
extern Switch  swJoyRight, swJoyLeft, swJoyDown, swJoyUp;            // declaration objet switch sur mouvemet joystick
extern Joystick  joyX;                 // declaration objet joystick
extern Joystick  joyY; 
extern Gyro mpu; 
extern Conf conf;
extern World *worlds;

gameStatusType    _gameStatus ;         // mode jeux  
displayModeType   _displayMode ;        // mode AFFICHAGE

Vector            scroll;            // scroll position of the screen in the world 
Vector            offset;            // decalage de l'ecran par rapport à la position centrée du joueur
          

// creation de players -------------------------------------------------------------------------
Skin   sprite = 
              {
                walkingSprite,
                24,
                32,
                8,
                16 
              };

elapsedMillis _timeMaptoGame;         // delay de retour d'affichage au jeux
              
Player player (sprite);   

Player monster (sprite);  

// jeu
boolean game()    
    {

  #define JOY_X_SENSIBILITY 120
  #define JOY_Y_SENSIBILITY 300

// affichage du jeux en fonction des états jeux       
        if (_gameStatus == START) 
                {
                  player.begin(worlds[conf.level]);
                  _gameStatus = PLAY;
                }
        
        else  if (_gameStatus==PLAY) // SEQUENCES DU JEU
                   {
                          if (_displayMode == NORMAL ) 
                              {
                              Vector j;
                              
                              if (conf.playGyro) j =  mpu.Joystick() ;
                              else 
                                {
                                  j.x =  (int16_t)(joyX.get()/JOY_X_SENSIBILITY);
                                  j.y =  (int16_t)(joyY.get()/JOY_Y_SENSIBILITY);
                                  
                                  if ( !j.y && conf.enableGyro) j.y = mpu.Joystick().y;
                                  
                                }
                              
                              player.play(
                                          worlds[conf.level],
                                          j,                            // joystick position 
                                          swDown.shortPress(),          // jump
                                          swMid.shortPress()            // action
                                                                                ); 
                              // BASCULE EN MODE OVERVIEW 
                              if ( swMid.longPress() )      //  
                                      {
                                        _timeMaptoGame = 0;
                                        _displayMode = OVERVIEW ;   
                                      }
                                }                                                      
                          else 
                               {
                                    worlds[conf.level].displayOverview( 0,   player.getScroll());  // display map overview mode 
                                    
                                    if   ( swMid.shortPress() || swDown.shortPress() )    _displayMode = NORMAL ;// retour au mode normal 
                               }
                              
                    if (_timeMaptoGame > 30000 && _displayMode == OVERVIEW)  _displayMode = NORMAL;   // in map overview mode, return to game after 30 s
                    }
              else                    // SEQUENCE SORTI
                    {
                      if (_gameStatus == GAMEOVER) 
                        {
                          oled.printXYColorSize ("GAME OVER", 9 ,  49, BLACK,  2);
                          oled.printXYColorSize ("GAME OVER", 10 ,  50, RED,  2);
                        }
                      else if (_gameStatus == CHANGEWORLD) oled.printXYColorSize ("NEW WORLD", 10 ,  50, RED,  2);
                           else if (_gameStatus == WIN) oled.printXYColorSize ("WIN !", 10 ,  50, RED,  2);
                    }

// changing of the game status along game events 
        
        if (  player.getFinish(worlds[conf.level])  ) 
                              {
                                 if (conf.level != nbworlds-1 )  _gameStatus=CHANGEWORLD;
                                 else _gameStatus = WIN;
                              }
                                 
        if (player.getLife() == 0)  _gameStatus=GAMEOVER;
     

// exit button and validation of game status changes 
    if (swUp.shortPress()) 
      {
        if (_gameStatus == PLAY) return HIGH;
        else if (_gameStatus == GAMEOVER) 
              {
                _gameStatus=START;
                return LOW;
              }
             
             else if (_gameStatus == CHANGEWORLD)
                      {
                        _gameStatus=START;
                        conf.level++;
                        if (conf.maxLevel < conf.level) conf.maxLevel=conf.level;
                        worlds[conf.level].setEnable(HIGH);
                        return LOW;
                      }
                  else if (_gameStatus == WIN) return HIGH;
                       else return LOW;
         }
    else return LOW;
   }

void    setScroll()
  {
    if (player.getSight().x==1) offset.x+=1; else offset.x-=1;
    if (player.getSight().y==1) offset.y+=1; else offset.y-=1;

    if (offset.x>25)  offset.x=25;  if (offset.x<-25)  offset.x=-25;
    if (offset.y>25)  offset.y=25;  if (offset.y<-25)  offset.y=-25;
    
    scroll.x = player.getPos().x - (63-12) + offset.x;
    scroll.y = player.getPos().y - (63-16) + offset.y;
   }
