

#include "Config.h"
#include "World.h"
#define PROG_VERSION "Knight_V2.56"

enum itemType { MENU, BOOLEANVALUE, PROG, WORLD};

// Prog 
boolean debug(); 

boolean progAbout(); 

boolean saveEeprom(); 

boolean goToSleep();

boolean resetWorlds(); 

boolean freezeScreen(); 

// menu
void menuManage();

void menuBegin();

class Item
{
    public:
        Item (
                String title,            // 
                uint8_t itemNb,          // if it is a MENU : items nb else 0  
                Item * items             // if it is a MENU : pointer of the items array else NULL
               );

        Item (
                String title,             // 
                boolean *booleanValue
               );

        Item (
                String title,             // 
                boolean (*prog)()         // pointer of the prog to be run
               );

        Item (
                World  *world             // pointer of the world
               );

        itemType _type;                       // type de l'item
        String _title;                        // titre de l'item ou du menu

        uint8_t _itemNb;                      // Nb d'item dans le menu
        Item * _items = NULL;                 // tableau des items
        
        boolean *_booleanValue = LOW;         // pointeur de la variable defini dans l'item de menu
  
        boolean (*_prog)() = NULL;            // pointeur de fonction de la routine executée

        void setBackMenu (uint8_t index, Item * menu);
        uint8_t _backIndex;
        Item * _backMenu = NULL ;
        
        uint8_t _index;                       // index du menu

        World * _world;                       // worlds
 
};
