
#ifndef PLAYER_H
#define PLAYER_H

#include "Config.h"
#include "WData.h"
#include "World.h"


class Player
{
  public:
          Player ( Skin skin);
          
          void    begin (World world); // positionne le joueur sur walkX et walkY dans le monde level sans splach screen pour l'initialisation dans le setup
          
          Vector  getPos();

          boolean getFinish(World world);
          
          Vector  getScroll();
          Vector  getSight();

          int16_t getLife();

          void    display(World world, Vector scroll);   // définis les mouvement du player
          
          void    play(World world, Vector dir, boolean jump, boolean action);   // définis les mouvement du player
          
          void    move(World world, Vector dir, boolean jump, boolean action);  

  private :

          Skin   _skin;
          uint8_t _frameNb;
          Vector _mask;
          uint8_t _overLapX;
          
          void    _setScroll();

          void    _displayLife (uint8_t x);

          void   _limitVector  (   // defini la limite d'un vector
                              Vector *v, 
                              int16_t xmin, int16_t xmax, 
                              int16_t ymin, int16_t ymax
                              ); 
                              
          void    _limit (int16_t *x, int16_t xmin, int16_t xmax);

          Vector    _pos  ;             // position du joueur dans la map
          Vector    _scroll;            // position de l'écran dans la map

          int8_t     _dy;                // vitesse en y du joueur
          
          Vector    _sight;             // direction ou regarde le joueur dans la map
          Vector    _offset;            // decalage de l'ecran par rapport à la position centrée du joueur
          
          byte      _frame;            // Image a afficher dans la séquence de marche du skin
          
          int16_t   _life;               // vie

          elapsedMillis _timeWalk;             // delay pour l'effet de marche du skin
          
          boolean _getKey, _getSword;                    // if get key

};

class Monster : public Player 
{
          void    begin (World world, Vector start); // 
          
};


#endif
