#ifndef TIME_CLOCK_H
#define TIME_CLOCK_H

#include <Time.h>  
#include <TimeLib.h>  
// https://www.pjrc.com/teensy/td_libs_Time.html
// https://playground.arduino.cc/Code/Time/

class TimeClock
{
public : 
     static boolean display();
     
     TimeClock();   
                                  
     void begin();
     
     String getTimeString ();

     String getDateString ();

     void handle();
     
     void draw (uint16_t digitsColor, uint16_t backGroundColor);                                      

private : 
  
  static time_t _getTeensy3Time();      // routine qui renvoi la variable de temp (type time_t = uint32_t)

  unsigned long _processSyncMessage();  // Synchronisation avec le PC lors le teensy est branché
  
  String _digitsToString (uint8_t digits); // renvoi une string pour un nombre deux chiffres

  boolean _setTimeDisplay; 
};

#endif
