# -*- coding: utf-8 -*-
import sys
import math
from PIL import Image

outputFileName = "../WData.h"

file = open(outputFileName,"w") 
nbWorld = 4


wo = 0

file.write ("// ***************************************************************************************************************************************************************************************************************************************************************************** " ) 
file.write('\n')
file.write ("// ******************************************* DATA  ******************************************************************************************************************************************************************************************************************* " ) 
file.write('\n')
file.write ("// ***************************************************************************************************************************************************************************************************************************************************************************** " ) 
file.write('\n')
file.write('\n')
file.write('\n')
file.write ("#ifndef DATA_H")
file.write('\n')
file.write ("#define DATA_H")
file.write('\n')



file.write('\n')
file.write("const uint8_t nbworlds = " + str(nbWorld) + ";")
file.write('\n')
file.write('\n')

for wo in range(nbWorld):

        print ("Generate world N°" + str(wo) + "--------------------------------------------------------"   )
        
        print 

 # GENERATE THE MAP  ***********************************************************************************

        # from tilesMap in .tmx format 
        # coding of 4 blocks per 16bit integer

        #try:    inputFileName = sys.argv[1]
        inputFileName = "World" + str(wo) + "/map" + str(wo) + ".tmx"

        inputFile = open(inputFileName ,"r")

        lines = inputFile.readlines()
        inputFile.close()

        size = len(lines)

#### Generate tiles map 
        # find the line Index for MapLayer
        indexLine = 0
        while  lines[indexLine].find( "MapLayer") == -1 :
               
                indexLine += 1


        # get w and h from the .tmx file

        indexdebut = lines[indexLine].find("width=") + 7 # information to read is in the line 3 
        indexfin = indexdebut + 3 

        wMap = int (lines[indexLine][indexdebut:indexfin] )

        indexdebut = lines[indexLine].find("height=") + 8 
        indexfin = indexdebut + 3 

        hMap = int (lines[indexLine][indexdebut:indexfin] )

# now we write the header of the array

        file.write('\n')
        file.write("// ------------------- blockMap " + str(wo) + "----------------------------------------------------------- blockMap " + str(wo) + "-----------------------------------------------------------blockMap " + str(wo) + "--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------" )
        file.write('\n')
        file.write('\n')
        file.write("const uint8_t blockMapWidth" + str(wo) + " = "  + str(wMap) + ";")
        file.write('\n')
        file.write("const uint8_t blockMapHeight" + str(wo) + " = "  + str(hMap) + ";")
        file.write('\n')
        file.write('\n')
        file.write("const uint16_t blockMap" + str(wo) + "["  + str(hMap) + "*" + str(wMap/4) +"] PROGMEM = {")
        file.write('\n')
        file.write('\n')


# generate the array itself--------------------------------------------------

        print ("Generate array of blockMap" + str(wo) + " : Map size :" + str (wMap) + "X" + str (hMap) )

        # find <data encoding="csv"> line Index
        indexLine = 0
        while  lines[indexLine].find( "data") == -1 :
                #print (indexLine)
                indexLine += 1

        indexLine += 1

        #print (" line for data")
        #print (indexLine)
    
        for y in range(indexLine,indexLine+hMap): # we parse the lines of the file from line N°5
                indexBlockStart = 0
                indexBlockEnd = 0
                i = 0         # count over 4 
                pHex = 0x0000 # 16 bit integer for coding 4 blocks 

                file.write(" ")
                for x in range(wMap): # we parse the blocks in a line 
                        
                        if i == 4:
                                i = 0
                                pHex = 0x0000 # codage sur 16 bit
                        
                        indexBlockEnd = lines[y].find(",", indexBlockStart ) 
                        block = int (lines[y][indexBlockStart:indexBlockEnd] ) - 1
                        indexBlockStart = indexBlockEnd + 1

                        pHex = pHex | (block << (12-4*i)) # we insert the block num int the uint16
                        
                        if i == 3:
                                file.write("{0:#0{1}X}".format(pHex, 6))

                                if y == hMap+indexLine-1 and x == wMap - 1:  # end closing of array
                                        file.write(" ") #no comma
                                else:        
                                        file.write(", ") # comma separation if int16
                        i += 1
    
                file.write("\n")
        file.write("};")

        
# GENERATE THE TEXTUREPACK   ***********************************************************************************

        print ("Generate array for packTexture" + str(wo) )
        
        columns = 32 # Number of columns in formatted output

        # Write hex digit (with some formatting for C array) to stdout
        def outputHex(n):
                global columns, column, counter, limit
                column += 1                        # Increment column number
                if column >= columns:              # If max column exceeded...
                        file.write("\n  ")   # end current line, start new one
                        column = 0                 # Reset column number
                file.write("{0:#0{1}X}".format(n, 6))
                counter += 1                       # Increment element index
                if counter < limit:                # If NOT last element in list...
                        file.write(",")      # add column between elements
                        if column < (columns - 1): # and space if not last column
                                file.write(" ")
                else:
                        file.write(" };");              # Cap off table

        file.write('\n')

        # OPEN AND VALIDATE IMAGE FILE --------------------------------------

        try:    filename = sys.argv[1]
        except: filename = "World" + str(wo) + "/packTexture" + str(wo) + ".bmp"
        im     = Image.open(filename)
        im     = im.convert("RGB")
        pixels = im.load()

        # GENERATE ARRAY ----------------------------------------------------

        # Initialize outputHex() global counters:
        counter = 0                            # Index of next element to generate
        column  = columns                      # Current column number in output
                     # Total # of elements in generated list

        w = im.size[0]
        h = im.size[1]
        limit   = h * w

        file.write('\n')
        file.write('\n')
        file.write('\n')
        file.write ("//------------------- packtexture " + str(wo) + "---------------------------------------------------------------------packtexture " + str(wo) + "---------------------------------------------------------------------- packtexture " + str(wo) + "---------------------------------------------------------------------")
        file.write('\n')
        file.write('\n')
        file.write("const uint8_t packTextureWidth" + str(wo) + " = "  + str(w) + ";")
        file.write('\n')
        file.write("const uint8_t packTextureHeight" + str(wo) + " = "  + str(h) + ";")
        file.write('\n')
        file.write('\n')
        file.write("const uint16_t packTexture" + str(wo) + "["  + str(w) +  "*" + str(h) +  "] PROGMEM = {")
        file.write('\n')

        # Convert 24-bit image to 16 bits:
        for y in range(h):
                for x in range(w/4):
                        char = 0x0000 # codage sur 16 bit
                        for i in range(4):
                                p = pixels[4*x+i, y] # Pixel data (tuple)
                                outputHex (((p[0] & 0b11111000) << 8) | # Convert 24-bit RGB
                                             ((p[1] & 0b11111100) << 3) | # to 16-bit value w/
                                           ( p[2] >> 3))             # 5/6/5-bit packing


        file.write('\n')

    
#### Generate doors tiles positions on map ***********************************************************************************

        # find the line Index for objetcs
       
        areThereDoors = 0
        
        # we check if there is a  doors layer in the array
        for i in range(indexLine+hMap, size):
                if lines[i].find( "Doors" ) != -1 :
                        indexLine = i 
                        areThereDoors = 1
                        break
        
        doorsNb = 0
        indexBlock = 0
        doorBlockList = []
        blocksNb = 0

        if areThereDoors == 1:
                # we find the data starting for door layer
                while  lines[indexLine].find( "data") == -1 :
                        indexLine += 1
                indexLine += 1

                # we scan le layer "doors"
                
                for y in range(0,hMap): # we scan the lines of the file from line n°<indexLines>
                        indexBlockStart = 0
                        indexBlockEnd = 0
                        
                        for x in range(wMap): # we scan the blocks in a line 
                        
                                indexBlockEnd = lines[y + indexLine].find(",", indexBlockStart ) # what is there between two commas
                                block = int (lines[y + indexLine][indexBlockStart:indexBlockEnd] )   # we extract the number
                                indexBlockStart = indexBlockEnd + 1 # and we pass to the following
                                
                                if block != 0:
                                        
                                        doorBlockList.append ( 0 )
                                        doorBlockList.append ( block - 1)
                                        doorBlockList.append ( x )
                                        doorBlockList.append ( y )
                                        
                blocksNb =  len(doorBlockList) / 4                        
                print
                print ("We find " + str(blocksNb) +" tiles for doors")
                print ("doorBlockList : " + str(blocksNb) )
                
                print ("->Generate list of doors for world N°" + str(wo)  )

                # now we combine the block in group

                indexDoor = 0
                b = 0
                while  b < blocksNb - 1 : # we scan the list of blocks
                        x0 = doorBlockList [ b * 4 + 2]
                        y0 = doorBlockList [ b * 4 + 3]
                        x1 = doorBlockList [ (b+1) * 4 + 2]
                        y1 = doorBlockList [ (b+1) * 4 + 3]

                        doorBlockList [ b * 4 ] = indexDoor

                        if ( x0 == x1 and y1 == y0 + 1 ) or ( y0 == y1 and x1 == x0 + 1 ) :
                                 doorBlockList [ (b+1) * 4 ] = indexDoor
                        else :
                                indexDoor += 1
                        b += 1
                                        
                # now we write the header of the array

                file.write('\n')
                file.write("// ------------------- doors list of map" + str(wo) + "-----------------------------------------------------------  "  )
                file.write('\n')
                file.write('\n')
                file.write("const uint8_t doorBlocksNb" + str(wo) + " = " + str( blocksNb ) + ";" )
                file.write('\n')
                file.write('\n')
                file.write("const uint8_t doors" + str(wo) + "[] PROGMEM = {")
                file.write('\n')
        
                for b in range(0, blocksNb ): # we scan the list of blocks

                        file.write( str( doorBlockList[b * 4] ) + ", " + str( doorBlockList[b * 4 + 1] ) + ", " + str( doorBlockList [b * 4 + 2] ) + ", " + str( doorBlockList [b * 4 + 3] ) + ", " + " // " + str(b ) )
                        file.write('\n')
                                         
                file.write("};")   # close the array of the last group
                file.write('\n')
                file.write('\n')
                file.write('\n')


        file.write('\n')
        print

#### Generate objects positions list on map ***********************************************************************************

        # find the line Index for objetcs
       
        areThereOjects = 0
        
        # we check if there are objects in the array
        for i in range(indexLine+hMap, size):
                if lines[i].find( "Objects" ) != -1 :
                        indexLine = i 
                        areThereOjects = 1
                        break

        # now we find the objects in the array
        numberOfObjects = 0

        if areThereOjects == 1:
                # we find the data starting for object layer
                while  lines[indexLine].find( "data") == -1 :
                        indexLine += 1
                indexLine += 1

                # generate the list of objects
                
                
                for y in range(indexLine,indexLine+hMap): # we parse the lines of the file from line n°<indexLines>
                        indexBlockStart = 0
                        indexBlockEnd = 0
                        for x in range(wMap): # we parse the blocks in a line 
                        
                                indexBlockEnd = lines[y].find(",", indexBlockStart ) # what is there between two commas
                                block = int (lines[y][indexBlockStart:indexBlockEnd] )  # we extract the number
                                indexBlockStart = indexBlockEnd + 1 # and we pass to the following
                                
                                if block != 0:
                                        numberOfObjects += 1
                                                             
                print
                print ("We find " + str(numberOfObjects) +" objects")
                print ("->Generate list of objects" + str(wo)  )
                # now we write the header of the array




                file.write('\n')
                file.write("// ------------------- objectsList " + str(wo) + "----------------------------------------------------------" )
                file.write('\n')
                file.write('\n')
                file.write("const uint16_t objectsNb" + str(wo) + " = " + str(numberOfObjects) + ";" )
                file.write('\n')
                file.write('\n')
                file.write("const uint8_t objectsList" + str(wo) + "[3*" + str(numberOfObjects) +"] PROGMEM = {")
                file.write('\n')
                file.write('\n')

                for y in range(0, hMap): # we parse the lines of the file from line n°<indexLines>

                        indexBlockStart = 0
                        indexBlockEnd = 0

                        for x in range(wMap): # we parse the blocks in a line 
                        
                                indexBlockEnd = lines[y + indexLine ].find(",", indexBlockStart ) # what is there between two commas
                                block = int (lines[ y + indexLine ][indexBlockStart:indexBlockEnd] )  # we extract the number
                                indexBlockStart = indexBlockEnd + 1 # and we pass to the following
                                
                                if block != 0:
                                         file.write( str(block-17) + ", " + str(x) + ", " + str(y - 1) + ", "  )
                                         
                                         file.write('\n')
                                         
                file.write( "};" ) # close the array
        
# Generate objets image array   ***********************************************************************************

        print ("->Generate image array for objects" + str(wo) )
        print
                
        columns = 64 # Number of columns in formatted output

        # Write hex digit (with some formatting for C array) to stdout
        def outputHex(n):
                global columns, column, counter, limit
                column += 1                        # Increment column number
                if column >= columns:              # If max column exceeded...
                        file.write("\n  ")   # end current line, start new one
                        column = 0                 # Reset column number
                file.write("{0:#0{1}X}".format(n, 6))
                counter += 1                       # Increment element index
                if counter < limit:                # If NOT last element in list...
                        file.write(",")      # add column between elements
                        if column < (columns - 1): # and space if not last column
                                file.write(" ")
                else:
                        file.write(" };");              # Cap off table

        file.write('\n')

        # OPEN AND VALIDATE IMAGE FILE --------------------------------------

        try:    filename = sys.argv[1]
        except: filename = "World" + str(wo) + "/Objects" + str(wo) + ".bmp"
        im     = Image.open(filename)
        im     = im.convert("RGB")
        pixels = im.load()

        # GENERATE ARRAY ----------------------------------------------------

        # Initialize outputHex() global counters:
        counter = 0                            # Index of next element to generate
        column  = columns                      # Current column number in output
                             # Total # of elements in generated list

        w = im.size[0]
        h = im.size[1]
        limit   = h * w

        file.write('\n')
        file.write('\n')
        file.write('\n')
        file.write ("//------------------- objectsImage -------------------------------------------------------------------objectsImage --------------------------------------------------------------------objectsImage ------------------------------------------------------------------")
        file.write('\n')
        file.write('\n')

        file.write("const uint16_t objects" + str(wo) + "[" + str(h) +"*" + str(w) + "] PROGMEM = {")
        file.write('\n')

        # Convert 24-bit image to 16 bits:
        for y in range(h):
                for x in range(w/4):
                        char = 0x0000 # codage sur 16 bit
                        for i in range(4):
                                p = pixels[4*x+i, y] # Pixel data (tuple)
                                outputHex (((p[0] & 0b11111000) << 8) | # Convert 24-bit RGB
                                                ((p[1] & 0b11111100) << 3) | # to 16-bit value w/
                                                ( p[2] >> 3))             # 5/6/5-bit packing

        file.write('\n')
    
# Generate Background  ***********************************************************************************

        print ("Generate array for Background" + str(wo) )

        columns = 64 # Number of columns in formatted output

        # Write hex digit (with some formatting for C array) to stdout
        def outputHex(n):
                global columns, column, counter, limit
                column += 1                        # Increment column number
                if column >= columns:              # If max column exceeded...
                        file.write("\n  ")   # end current line, start new one
                        column = 0                 # Reset column number
                file.write("{0:#0{1}X}".format(n, 6))
                counter += 1                       # Increment element index
                if counter < limit:                # If NOT last element in list...
                        file.write(",")      # add column between elements
                        if column < (columns - 1): # and space if not last column
                                file.write(" ")
                else:
                        file.write(" };");              # Cap off table


        # OPEN AND VALIDATE IMAGE FILE --------------------------------------

        try:    filename = sys.argv[1]
        except: filename = "World" + str(wo) + "/backGround" + str(wo) + ".bmp"
        im     = Image.open(filename)
        im     = im.convert("RGB")
        pixels = im.load()

        # GENERATE  ARRAY ----------------------------------------------------

        # Initialize outputHex() global counters:
        counter = 0                       # Index of next element to generate
        column  = columns                 # Current column number in output
        limit   = im.size[0] * im.size[1] # Total # of elements in generated list


        file.write('\n')
        file.write('\n')
        file.write('\n')
        file.write ("//------------------- Background " + str(wo) + "---------------------------------------------------------------------- Background -" + str(wo) + "------------------------------------------------------------------- Background " + str(wo) + "------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------")
        file.write('\n')
        file.write('\n')
        file.write("const uint8_t backGroundWidth" + str(wo) + " = "  + str(im.size[0]) + ";")
        file.write('\n')
        file.write("const uint8_t backGroundHeight" + str(wo) + " = "  + str(im.size[1]) + ";")
        file.write('\n')

        file.write("const uint16_t backGround" + str(wo) + "["+str(im.size[1])+"*"+str(im.size[0])+ "] PROGMEM= {")
        file.write('\n')
        file.write('\n')

        # Convert 24-bit image to 16 bits:
        for y in range(im.size[1]):
                for x in range(im.size[0]):
                        p = pixels[x, y] # Pixel data (tuple)
                        outputHex(
                                (p[0] & 0b11111000) << 8 |    # Convert 24-bit RGB
                                (p[1] & 0b11111100) <<  3 |  # to 16-bit value w/
                                (p[2] & 0b11111000)  >> 3
                                )   # 5/6/5-bit packing

        file.write('\n')
        print


# Generate start and finish   ***********************************************************************************

        print ("Generate start and finish" + str(wo) )

        isThereStart = 0
   # we check if there is start object in the map
        
        for i in range(0,len(lines) ):
                if lines[i].find( "start") > 1 :
                        isThereStart = 1
                        indexLine = i
                
                                        

        if isThereStart == 1 :
                charStart  = lines[indexLine].find("x=", 0) + 3
                charEnd =  lines[indexLine].find('"', charStart ) # what is there between two commas

                xStart = int (lines[indexLine][charStart:charEnd ]) >> 3

                charStart  = lines[indexLine].find("y=", 0) + 3
                charEnd =  lines[indexLine].find('"', charStart ) # what is there between two commas

                yStart = int (lines[indexLine][charStart:charEnd ]) >> 3

        isThereFinish = 0
     # we check if there is finish object in the map
        for i in range(0,len(lines) ):
                if lines[i].find( "finish") > 1 :
                        isThereFinish = 1
                        indexLine = i
                        

        if isThereFinish == 1:
                charStart =  lines[indexLine].find("x=", 0) + 3
                charEnd =  lines[indexLine].find('"', charStart ) # what is there between two commas

                xFinish = int (lines[indexLine][charStart:charEnd ]) >> 3

                charStart =  lines[indexLine].find("y=", 0) + 3
                charEnd =  lines[indexLine].find('"', charStart ) # what is there between two commas

                yFinish = int (lines[indexLine][charStart:charEnd ]) >> 3
                                

                print ("->start    "  + str (xStart) + "   " + str (yStart))
                print ("->finish   "  + str (xFinish) +"   " + str (yFinish))
                print

                file.write('\n')
                file.write("// start and finish points ------------------------------------------" )
                file.write('\n')
                file.write( "const Vector  start" + str(wo) + "   = { " + str (xStart) + " , " + str (yStart)  + "};")
                file.write('\n')
                file.write( "const Vector  finish" + str(wo) + "  = { " + str (xFinish) +" , " + str (yFinish) + "};")
                file.write('\n')
                file.write('\n')
        

# Generate Skin Image ********************************************************$

print ("------------------------------------------------------------------------------------" )
print ("Generate image array for skins" )
columns = 192 # Number of columns in formatted output

# Write hex digit (with some formatting for C array) to stdout
def outputHex(n):
	global columns, column, counter, limit
	column += 1                        # Increment column number
	if column >= columns:              # If max column exceeded...
		file.write("\n  ")   # end current line, start new one
		column = 0                 # Reset column number
	file.write("{0:#0{1}X}".format(n, 6))
	counter += 1                       # Increment element index
	if counter < limit:                # If NOT last element in list...
		file.write(",")      # add column between elements
		if column < (columns - 1): # and space if not last column
			file.write(" ")
	else:
		file.write(" };");              # Cap off table


# OPEN AND VALIDATE IMAGE FILE --------------------------------------

try:    filename = sys.argv[1]
except: filename = "Skins/walkingSprite.bmp"
im     = Image.open(filename)
im     = im.convert("RGB")
pixels = im.load()

# GENERATE ARRAY ----------------------------------------------------

# Initialize outputHex() global counters:
counter = 0                            # Index of next element to generate
column  = columns                      # Current column number in output
             # Total # of elements in generated list

w = im.size[0]
h = im.size[1]
limit   = h * w

file.write
file.write('\n')
file.write('\n')
file.write("// sequence walkingSprite  --------------------------------------------------------------------------------------------------")
file.write('\n')
file.write('\n')
file.write("const uint16_t walkingSprite[192*32] PROGMEM = {")

# Convert 24-bit image to 16 bits:
for y in range(h):
        for x in range(w):
                char = 0x0000 # codage sur 16 bit
                p = pixels[x, y] # Pixel data (tuple)
                outputHex (((p[0] & 0b11111000) << 8) | # Convert 24-bit RGB
                             ((p[1] & 0b11111100) << 3) | # to 16-bit value w/
                           ( p[2] >> 3))             # 5/6/5-bit packing

file.write('\n')
        
file.write('\n')
file.write('\n')
file.write('\n')
file.write ("#endif")
file.write('\n')
file.write('\n')
file.write('\n')
file.write ("// the end !")        
file.close()     


print
print ("finished !")
print ("Check file " + outputFileName + " ...  it was paste in your sketch folder ..." )
print
print ("See you")

